#ifndef FGGL_GFX_RENDERER_H
#define FGGL_GFX_RENDERER_H

#include <vector>

#include <fggl/data/model.hpp>
#include <fggl/ecs/ecs.hpp>
#include <fggl/gfx/ogl.hpp>

namespace fggl::gfx {

	struct GlRenderToken {
		GLuint vao;
		GLuint buffs[2];
		GLuint idxOffset;
		GLuint idxSize;
		GLuint pipeline;
	};

	class GlMeshRenderer {
		public:
			using token_t = GlRenderToken;

			token_t upload(fggl::data::Mesh& mesh);

			// are VAO safe across opengl contexts? :S
			void render(const Window& window, const fggl::ecs::ECS& ecs, float dt);

			float total;
	};

	// specialisation hooks
	using Graphics = GlGraphics;
	using MeshRenderer = GlMeshRenderer;
	using MeshToken = GlRenderToken;

};

#endif
